3 # Common functions for build scripts used by various packages
4 # incorporated (e.g., build, myplc, myplc-devel, vserver-reference)
6 # Marc E. Fiuczynski <mef@cs.princeton.edu>
7 # Copyright (C) 2007 The Trustees of Princeton University
12 # support for fedora and centos only for now
14 function pl_getDistro() {
15 if [ -f "/etc/redhat-release" ] ; then
16 distro=$(awk ' { print $1 } ' /etc/redhat-release)
18 echo "build.common.pl_getDistro-unknown"
25 function pl_getRelease() {
26 if [ -f "/etc/redhat-release" ] ; then
27 release=$(awk ' { if ($1=="Fedora" && $2=="Core") print $4 ; if (($1=="Fedora" && $2!="Core")||$1=="CentOS") print $3 } ' /etc/redhat-release)
29 echo "build.common.pl_getRelease-unknown"
36 # vserver expects something like f8 or centos5
37 function pl_getReleaseName () {
52 releasename="unknown-name-for-${pl_DISTRO}-please-edit-build.common"
53 echo 1>&2 "build.common: WARNING - releasename not set for distro=$distro"
61 # on fedora 8 or 9, we use libnl from the stock repos
62 # on centos5 we build it locally
63 function pl_getKexcludes () {
67 echo 'kernel* util-vserver* iptables iproute'
70 echo 'kernel* util-vserver* iptables iproute inotify-tools* libnl*'
73 echo "pl_DISTRO_NAME=$pl_DISTRO_NAME not supported in getexcludes.sh"
79 # figure out which redhat distro we are using (fedora, centos, redhat)
80 pl_DISTRO=$(pl_getDistro)
82 # select basearch of the host devel environment - protected for macos for local tests
83 pl_DISTRO_ARCH=$(uname -i 2>/dev/null|| echo unknownarch)
85 # the release number (plain number)
86 pl_DISTRO_RELEASE=$(pl_getRelease)
88 # the release name - for vserver build ...
89 pl_DISTRO_NAME=$(pl_getReleaseName $pl_DISTRO $pl_DISTRO_RELEASE)
91 # the packages to exclude
92 pl_KEXCLUDES=$(pl_getKexcludes $pl_DISTRO_NAME)
94 # get path to appropriate yumgroups.xml file
95 # Thierry: quick & dirty improvement
96 # this file is updated by the toplevel build, from the .pkgs files
97 pl_DISTRO_YUMGROUPS="../../../RPMS/yumgroups.xml"
99 function pl_process_fedora_options () {
102 while getopts "l:r:a:h" opt ; do
105 pl_DISTRO_URL=$OPTARG
106 let shiftcount=$shiftcount+2
109 pl_DISTRO_RELEASE=$OPTARG
110 let shiftcount=$shiftcount+2
113 pl_DISTRO_ARCH=$OPTARG
114 let shiftcount=$shiftcount+2
117 echo "Usage: $0 [OPTION]..."
118 echo " -l url distro mirror location (default: $pl_DISTRO_URL)"
119 echo " -r release distro release number (default: $pl_DISTRO_RELEASE)"
120 echo " -a arch distro architecture (default: $pl_DISTRO_ARCH)"
121 echo "where distro can be either fedora, centos, or redhat"
122 echo " -h This message"
130 ######################################## handling a root image
131 function pl_root_rpm_macros () {
133 %_install_langs C:en_US:en
134 %_netsharedpath /proc:/dev/pts:/usr/share/info
136 %__file_context_path /dev/null
140 function pl_root_makedevs() {
142 # Clean ${vroot}/dev, but only when ${vroot}!=""
143 [ -n $vroot ] && rm -rf $vroot/dev
146 mknod -m 666 $vroot/dev/null c 1 3
147 mknod -m 666 $vroot/dev/zero c 1 5
148 mknod -m 666 $vroot/dev/full c 1 7
149 mknod -m 644 $vroot/dev/random c 1 8
150 mknod -m 644 $vroot/dev/urandom c 1 9
151 mknod -m 666 $vroot/dev/tty c 5 0
152 mknod -m 666 $vroot/dev/ptmx c 5 2
153 # For bash command substitution
154 ln -nsf ../proc/self/fd $vroot/dev/fd
156 # For df and linuxconf
157 touch $vroot/dev/hdv1
160 mkdir -p $vroot/dev/pts
162 # (Might have to remove the following for vserver-reference.)
165 mkdir -p $vroot/dev/shm
168 mkdir -p $vroot/dev/net
169 mknod -m 600 $vroot/dev/net/tun c 10 200
171 # For mkinitrd (in case a kernel is being installed)
172 # As well for loop back mounting within a vserver.
173 for i in $(seq 0 255) ; do
174 mknod -m 640 $vroot/dev/loop$i b 7 $i
178 function mkfedora_usage() {
179 echo "Usage: pl_root_mkfedora [OPTION]... basedir pldistro pkgsfile(s)"
180 echo " -l url Fedora mirror location."
181 echo " Defaults are searched in <pldistro>.mirrors"
182 echo " -v Be verbose"
183 echo " -h This message"
184 echo " target selection (defaults based on current build vserver)"
185 echo " -r release Fedora release number (default: $releasever)"
186 echo " -a arch Fedora architecture (default: $basearch)"
190 function pl_root_mkfedora () {
192 echo "* Entering pl_root_mkfedora" "$@"
194 if [ $UID -ne 0 ] ; then
195 echo "Error: You must run this script as root."
202 # Release and architecture to install : defaults to current vserver's settings or previously parsed fedora_options
203 releasever=$pl_DISTRO_RELEASE
204 basearch=$pl_DISTRO_ARCH
207 while getopts "vh" opt ; do
209 v) verbose=1; set -x ;;
210 h|*) mkfedora_usage ;;
214 shift $(($OPTIND - 1))
215 [[ "$#" -lt 3 ]] && mkfedora_usage
219 vroot=$(cd $vroot && pwd -P)
220 [ -d $vroot ] || mkfedora_usage
223 # parse pkgsfile and add to local vars
224 fcdistro=${pl_DISTRO_NAME}
225 pkgs_packages=$(pl_parsePkgs package $fcdistro $pldistro $pkgsfile)
226 pkgs_groups=$(pl_parsePkgs group $fcdistro $pldistro $pkgsfile)
227 # packages to exclude
228 pkgs_excludes=$(pl_parsePkgs exclude $fcdistro $pldistro $pkgsfile)
229 # what can get trashed to save space
230 pkgs_junk=$(pl_parsePkgs junk $fcdistro $pldistro $pkgsfile)
232 pkgs_precious=$(pl_parsePkgs precious $fcdistro $pldistro $pkgsfile)
233 # formerly related to mkfedora -k : packages to take from our own build
234 # and thus need be excluded frem the stock repos
235 pkgs_kexcludes=$(pl_parsePkgs kexclude $fcdistro $pldistro $pkgsfile | sed -e s,@KEXCLUDE@,"$pl_KEXCLUDES",)
236 # get mirrors if not specified with -l
237 if [ -z "$mirrors" ] ; then
238 mirrorsfile=$(pl_locateDistroFile ../build/ $pldistro "$pldistro.mirrors")
239 mirrors=$(pl_parsePkgs mirror $fcdistro $pldistro $mirrorsfile)
243 # add them manually as the output of pl_parsePkgs is line-separated
244 if [ -n "$pkgs_kexcludes" ] ; then
245 kexclude_line="exclude="
246 for kexclude in $pkgs_kexcludes ; do
247 kexclude_line="$kexclude_line $kexclude"
251 echo "$0: candidate mirrors"
252 for mirror in $mirrors ; do
253 echo "* candidate mirror $mirror"
256 # the repo part of the final yum.conf
257 yum_conf_repos=$vroot/xxxmkfedora-repos.confxxx
258 if ! yumconf_mirrors $yum_conf_repos ../build/ $fcdistro "$kexclude_line" $mirrors ; then
259 echo xxx -- error ; return 1
262 public_gpg_key=$(yumconf_gpgkey $yum_conf_repos)
264 # Do not tolerate errors
267 ## make rpms ignore installing stuff to special fs entries like /proc
268 # Because of https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=52725
269 # you have to use at least one language beside 'C'
270 # Prevent all locales from being installed in reference image
271 mkdir -p $vroot/etc/rpm
272 pl_root_rpm_macros > $vroot/etc/rpm/macros
274 # Trick rpm and yum, who read the real root /etc/rpm/macros file
275 # rather than the one installed in the reference image, despite what
276 # you might expect the --root and --installroot options to mean. Both
277 # programs always read $HOME/.rpmmacros.
278 export HOME=$vroot/tmp
280 pl_root_rpm_macros > $vroot/tmp/.rpmmacros
282 function mkfedora_cleanup () {
283 umount -l $vroot/proc
284 umount -l $vroot/dev/shm
285 umount -l $vroot/dev/pts
288 # Clean up before exiting if anything goes wrong
289 trap "mkfedora_cleanup" ERR INT
291 # Mount in reference image
292 mount -t devpts none $vroot/dev/pts
293 mount -t tmpfs none $vroot/dev/shm
295 mount -t proc none $vroot/proc
297 # Create a /var/lib dirs for yum & rpm
298 mkdir -p $vroot/var/lib/yum
299 mkdir -p $vroot/var/lib/rpm
300 mkdir -p $vroot/usr/share/info
302 # Create a dummy /etc/fstab in reference image
304 cat >$vroot/etc/fstab <<EOF
305 # This fake fstab exists only to please df and linuxconf.
306 /dev/hdv1 / ext2 defaults 1 1
308 cp $vroot/etc/fstab $vroot/etc/mtab
310 # Necessary for some scripts
311 mkdir -p $vroot/etc/sysconfig
312 echo "NETWORKING=yes" > $vroot/etc/sysconfig/network
314 # Initialize RPM database in reference image
315 mkdir -p $vroot/var/lib/rpm
316 rpm --root $vroot --initdb
317 rpm --root $vroot --import $public_gpg_key
319 # Initialize yum in reference image
320 mkdir -p $vroot/var/cache/yum $vroot/var/log
322 # yum.conf is for building only - store in different location than /etc/yum.conf
323 yum_conf=$vroot/etc/mkfedora-yum.conf
324 cat > $yum_conf <<EOF
326 cachedir=/var/cache/yum
328 logfile=/var/log/yum.log
330 distroverpkg=redhat-release
336 # Prevent yum-2.4 from loading additional repository definitions
337 # (e.g., from /etc/yum.repos.d/)
341 cat $yum_conf_repos >> $yum_conf
343 # If we are being built as part of an automated RPM build, solve the
344 # bootstrap problem by including any just built packages in the yum
345 # configuration. This cooperates with the PlanetLab build system.
346 if [ -n "$RPM_BUILD_DIR" ] ; then
347 RPM_RPMS_DIR=$(cd $(dirname $RPM_BUILD_DIR)/RPMS && pwd -P)
348 # If run under sudo, allow user to delete the headers/ and
349 # repodata/ directories.
350 if [ -n "$SUDO_USER" ] ; then
351 chown -R $SUDO_USER $RPM_RPMS_DIR
353 cat >> $yum_conf <<EOF
356 name=Building - $basearch - $RPM_RPMS_DIR/
357 baseurl=file://$RPM_RPMS_DIR/
361 echo "========== Dumping $yum_conf"
363 echo "========== EndDump $yum_conf"
366 yum --help | grep verbose &> /dev/null && yum_options="$yum_options --verbose"
367 yum_options="$yum_options -y"
368 yum_options="$yum_options -c $yum_conf"
369 yum_options="$yum_options --installroot=$vroot"
372 for exclude in $pkgs_excludes; do
373 exclude_arg="$exclude_arg --exclude $exclude"
376 # glibc must be specified explicitly for the correct arch to be
378 echo "* Installing glibc"
379 yum $yum_options $exclude_arg install glibc
382 if [ -n "$pkgs_packages" ] ; then
383 echo "* Installing optional packages" $pkgs_packages
384 yum $yum_options $exclude_arg install $pkgs_packages
385 if ! rpm --root $vroot -q $pkgs_packages >/dev/null ; then
386 echo "* Warning: Missing packages"
387 rpm --root $vroot -q $pkgs_packages | grep "not installed"
391 if [ -n "$pkgs_groups" ] ; then
392 ## call yum sequentially to get finer-grained info on dependencies
393 for grp in $pkgs_groups ; do
394 echo "* Installing optional group $grp"
395 yum $yum_options $exclude_arg groupinstall "$grp"
399 # formerly in bootcd/prep.sh : to optimize footprint
400 if [ -n "$pkgs_junk" ] ; then
401 echo "* Removing unnecessary junk"
403 # Save precious files
404 [ -n "$pkgs_precious" ] && tar --ignore-failed-read -cpf precious.tar $pkgs_precious
405 # Remove unnecessary junk
406 [ -n "$pkgs_junk" ] && rm -rf $pkgs_junk
407 # Restore precious files
408 [ -n "$pkgs_precious" ] && tar -xpf precious.tar && rm -f precious.tar
414 yum $yum_options clean all
417 rm -f $vroot/var/lib/rpm/__db*
419 # Set time zone to UTC
420 if [ -f $vroot/usr/share/zoneinfo/UTC -a -f $vroot/etc/localtime ] ; then
421 rm -f $vroot/etc/localtime
422 ln -s /usr/share/zoneinfo/UTC $vroot/etc/localtime
425 echo "Dumping current list of rpms in /etc/mkfedora-rpms.txt"
426 chroot $vroot rpm -aq | sort > $vroot/etc/mkfedora-rpms.txt
428 # remove trap handler, as we are about to call it directly.
437 function pl_root_tune_image () {
440 # Disable all services in reference image
441 chroot $root sh -c "/sbin/chkconfig --list | awk '{ print \$1 }' | xargs -i /sbin/chkconfig {} off"
443 # FC2 minilogd starts up during shutdown and makes unmounting
444 # impossible. Just get rid of it.
445 rm -f $root/sbin/minilogd
446 ln -nsf /bin/true $root/sbin/minilogd
448 # This tells the Boot Manager that it is okay to update
449 # /etc/resolv.conf and /etc/hosts whenever the network configuration
450 # changes. Users are free to delete this file.
451 touch $root/etc/AUTO_UPDATE_NET_FILES
454 # Move specified directories out of a src tree into a dst tree, and
455 # then for each moved directory create a symlink in src to dst.
456 function pl_move_dirs() {
463 for datadir in "$@" ; do
464 mkdir -p ${data}${datadir}
465 if [ -d ${root}/${datadir} -a ! -h ${root}/${datadir} ] ; then
466 (cd ${root} && find ./${datadir} | cpio -p -d -u ../${data}/)
468 rm -rf ${root}/${datadir}
469 mkdir -p $(dirname ${root}/${datadir})
470 ln -nsf ${store}/${datadir} ${root}/${datadir}
474 # Construct an image file from given some directory
475 # XXX in the future maybe use livecdtools?
476 function pl_make_image() {
481 # Leave about 100 MB free space and allow for about 20% inode overhead
482 bytes=$((($(du -sb $root | cut -f1) + $extraspace) * 120 / 100))
484 blocks=$(($bytes / $bs))
485 dd bs=$bs count=$blocks if=/dev/zero of=$image
486 mkfs.ext3 -b $bs -j -F $image
488 # Temporarily mount it
489 tmp=$(mktemp -d tmp.XXXXXX)
490 mount -o loop $image $tmp
491 trap "umount $tmp; rmdir $tmp" ERR INT
494 (cd $root && tar cpf - .) | (cd $tmp && tar xpf -)
502 # Fix permissions on tmp directories
503 function pl_fixtmp_permissions() {
505 chmod 1777 $root/tmp $root/usr/tmp $root/var/tmp
508 function pl_fixdirs() {
511 for datadir in datadirs ; do
512 if [ -h ${root}/${datadir} ] ; then
513 rm -f ${root}/${datadir}
514 mkdir -p ${root}/${datadir}
519 ########## .pkgs format
520 # comments start with a # - this is needed only if you use a keyword in a comment
522 function pl_getPkgsAttribute () {
525 # remove any initial white spaces from the result
526 grep -v '^#' $file | grep --regexp="^${keyword}:" | sed -e "s,${keyword}:,," -e "s,^[[:space:]][[:space:]]*,,"
529 # for a given keyword like 'package' :
530 # we support fcdistro-dependant format, for tokens (pkgname) without whitespace
532 # package: pkg1 .. pkgn
533 # package+f8: pkg1 .. pkgn
534 # package-f8: pkg1 .. pkgn
536 # values can contain @arch@, @fcdistro@ or @pldistro@ that are replaced with the current values
538 # Usage: pl_parsePkgs keyword [-a arch] fcdistro pldistro pkgs-file[..s]
539 # the reason for the -a option is for when we build the build vserver itself; in this case
540 # pl_DISTRO_ARCH is the one we obtain from the root context, and that's wrong
541 # specify -sa arch AFTER keyword, so as to keep pl_getPackages and pl_getGroups simple
543 function pl_parsePkgs () {
545 target_arch=$pl_DISTRO_ARCH
547 [ "$1" == "-a" ] && { shift; target_arch="$1"; shift; }
550 # remaining arguments are paths to the pkgs files
552 # grab regular descriptions
553 all=$(grep -v '^#' "$@" | grep --regexp="^${keyword}:" | sed -e "s,${keyword}:,,")
555 add=$(grep -v '^#' "$@" | grep --regexp="^${keyword}+${fcdistro}:" | sed -e "s,${keyword}+${fcdistro}:,,")
557 sub=$(grep -v '^#' "$@" | grep --regexp="^${keyword}-${fcdistro}:" | sed -e "s,${keyword}-${fcdistro}:,,")
559 for rpm in $all $add; do
560 for exclude in $sub; do
561 [ "$rpm" = "$exclude" ] && continue 2
563 echo "${rpm} " | sed -e "s,@arch@,${target_arch},g" -e "s,@fcdistro@,$fcdistro,g" -e "s,@pldistro@,$pldistro,g"
568 # usage: pl_getPackages [-a arch] fcdistro pldistro pkg-file[..s]
569 function pl_getPackages() { pl_parsePkgs package "$@" ; }
570 function pl_getGroups() { pl_parsePkgs group "$@" ; }
572 # locates a pldistro-dependant file
573 # tries first in build/<pldistro>/, then in build/planetlab/
574 function pl_locateDistroFile () {
581 paths="$builddir/config.$pldistro/$pkgsfile $builddir/config.planetlab/$pkgsfile"
582 for path in $paths; do
583 if [ -f $path ] ; then
588 if [ -z "$pkgspath" ] ; then
589 echo 1>&2 "pl_locateDistroFile - in $(pwd) : cannot locate $pkgsfile in $builddir"
590 echo 1>&2 "candidates were $paths"
591 echo "not-found-by-pl_locateDistroFile"
594 echo 1>&2 "pl_locateDistroFile: using $pkgspath"
600 function yumgroups_from_pkgs () {
606 sedargs="-e s,@FCDISTRO@,$fcdistro,g"
609 <?xml version="1.0"?>
610 <!DOCTYPE comps PUBLIC "-//Red Hat, Inc.//DTD Comps info//EN" "comps.dtd">
614 for pkgsname in $pkgsnames; do
615 pkgsfile=$(pl_locateDistroFile $builddir $pldistro $pkgsname)
616 packages=$(pl_getPackages $fcdistro $pldistro $pkgsfile)
618 groupname=$(pl_getPkgsAttribute groupname $pkgsfile | sed $sedargs)
619 groupdesc=$(pl_getPkgsAttribute groupdesc $pkgsfile | sed $sedargs)
621 if [ -z "$groupname" -o -z "$groupdesc" ] ; then
622 echo "Cannot find groupname: and groupdesc: in $pkgsfile -- skipped" 1>&2
626 cat << __group_header
628 <id>$(echo $groupname|tr A-Z a-z)</id>
629 <name>$groupname</name>
630 <description>$groupdesc</description>
631 <uservisible>true</uservisible>
634 for package in $packages; do
635 echo "<packagereq type=\"mandatory\">$package</packagereq>"
637 cat << __group_footer
648 function build_fetch () {
649 curl --fail --silent --max-time 60 --output /dev/null "$1"
652 # tries to compute a valid yum.conf for that pldistro from the template in mirroring/
653 # returns 0 and writes <dest_yumconf> on success
654 # returns 1 on failure, in which case <dest_yumconf> is deleted
655 function yumconf_mirrors () {
656 dest_yumconf=$1; shift
659 kexclude_line="$1" ; shift
662 template=$builddir/mirroring/$fcdistro/yum.repos.d/building.repo.in
664 if [ ! -f $template ] ; then
665 echo "yumconf_mirrors: cannot locate template $template"
670 for mirror in $mirrors; do
671 if yumconf_mirror $dest_yumconf $template "$kexclude_line" $mirror; then
679 # computes a yum.conf from the template, and checks that all baseurl defined in there are valid repos
680 # returns 0 on success and 1 on failure
681 function yumconf_mirror () {
682 dest_yumconf=$1; shift
684 kexclude_line="$1" ; shift
687 sed -e "s,@MIRRORURL@,$mirror,g" \
689 $kexclude_line" $template > $dest_yumconf
691 # capture all lines defining baseurl
692 baseurl_defs=$(grep '^baseurl=' $dest_yumconf)
693 if [ -z "$baseurl_defs" ] ; then
697 for baseurl_def in $baseurl_defs; do
698 baseurl=$(echo $baseurl_def | sed \
700 -e 's,$basearch,'"$pl_DISTRO_ARCH",g)
701 repomd=$baseurl/repodata/repomd.xml
703 echo "* Trying to fetch $repomd"
704 if ! build_fetch $repomd ; then
705 echo "* Failed to fetch $repomd"
709 echo "* Selected mirror $mirror"
713 # from a yum.conf as generated above, computes the (first) gpgkey url
714 function yumconf_gpgkey () {
715 dest_yumconf=$1; shift
717 first_line=$(grep '^gpgkey=' $dest_yumconf | head -1)
718 values=$(echo $first_line | sed -e s,gpgkey=,,)
719 value=$(echo $values | awk '{print $1;}' | sed -e 's,$basearch,'"$pl_DISTRO_ARCH",g)
720 [ -n "$value" ] || return 1
725 # patches a yum conf to insert an exclude line in each declared repo
726 function yumconf_exclude () {
728 kexclude_line="$1" ; shift
730 sed -i -e "/baseurl=.*$/i\\
731 $kexclude_line" $repo